<template>
    <div class="password">
        <v-row
            :class="[
                { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
            ]"
        >
            <v-col v-if="$vuetify.breakpoint.mdAndUp" cols="3">
                <menu-bar />
            </v-col>
            <v-col>
                <v-row
                    :class="[
                        { 'pt-16 pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col>
                        <h1 class="font-syne-bold">
                            {{ $t('dashboard.menu.CHANGEPASSWORD') }}
                        </h1>
                    </v-col>
                </v-row>

                <v-form
                    v-show="pageLoaded"
                    ref="passwordForm"
                    lazy-validation
                    @submit.prevent
                >
                    <v-row
                        :class="[
                            {
                                'pl-0 pr-0': $vuetify.breakpoint.smAndDown,
                            },
                            {
                                'pl-16 pr-16 pb-16':
                                    $vuetify.breakpoint.mdAndUp,
                            },
                        ]"
                    >
                        <v-col cols="12">
                            <!-- EDIT PASSWORD FORM -->
                            <v-row>
                                <v-col cols="12" md="6" class="form-field pb-0">
                                    <!-- PASSWORD -->
                                    <v-text-field
                                        ref="password"
                                        v-model="form.password.value"
                                        :append-icon="
                                            showPass ? 'mdi-eye' : 'mdi-eye-off'
                                        "
                                        :rules="[requiredRules, requiredMin]"
                                        :type="showPass ? 'text' : 'password'"
                                        name="input-10-2"
                                        :label="$t('form.password.text')"
                                        :placeholder="
                                            $t('form.password.placeholder')
                                        "
                                        :hint="$t('form.password.min')"
                                        class="input-group--focused"
                                        solo
                                        @click:append="showPass = !showPass"
                                    ></v-text-field
                                ></v-col>
                            </v-row>
                            <v-row>
                                <v-col cols="12" md="6" class="form-field py-0">
                                    <!-- NEW PASSWORD -->
                                    <v-text-field
                                        ref="newPassword"
                                        v-model="form.newPassword.value"
                                        :append-icon="
                                            showNewPass
                                                ? 'mdi-eye'
                                                : 'mdi-eye-off'
                                        "
                                        :rules="[requiredRules, requiredMin]"
                                        :type="
                                            showNewPass ? 'text' : 'password'
                                        "
                                        name="input-10-2"
                                        :label="$t('form.newPassword.text')"
                                        :placeholder="
                                            $t('form.newPassword.placeholder')
                                        "
                                        :hint="$t('form.newPassword.min')"
                                        class="input-group--focused"
                                        solo
                                        @click:append="
                                            showNewPass = !showNewPass
                                        "
                                    ></v-text-field
                                ></v-col>
                            </v-row>
                            <v-row>
                                <v-col cols="12" md="6" class="form-field py-0">
                                    <!-- CONFIRM PASSWORD -->
                                    <v-text-field
                                        ref="confirmPassword"
                                        v-model="form.confirmPassword.value"
                                        :append-icon="
                                            showConfirmPass
                                                ? 'mdi-eye'
                                                : 'mdi-eye-off'
                                        "
                                        :rules="[
                                            requiredRules,
                                            requiredMin,
                                            requiredMatch,
                                        ]"
                                        :type="
                                            showConfirmPass
                                                ? 'text'
                                                : 'password'
                                        "
                                        name="input-10-2"
                                        :label="$t('form.confirmPassword.text')"
                                        :placeholder="
                                            $t(
                                                'form.confirmPassword.placeholder'
                                            )
                                        "
                                        :hint="$t('form.confirmPassword.min')"
                                        class="input-group--focused"
                                        solo
                                        @click:append="
                                            showConfirmPass = !showConfirmPass
                                        "
                                    ></v-text-field
                                ></v-col>
                            </v-row>
                            <!-- SUBMIT BUTTON -->
                            <v-row>
                                <v-col>
                                    <v-btn
                                        :block="$vuetify.breakpoint.smAndDown"
                                        class="lowercase br-0 pl-10 pr-10 font-syne-bold"
                                        color="badge"
                                        :loading="isButtonDisabled"
                                        :disabled="isButtonDisabled"
                                        @click="validateForm"
                                        >{{ $t('buttons.saveBtn') }}</v-btn
                                    >
                                </v-col>
                            </v-row>
                        </v-col>
                    </v-row>
                </v-form>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import MenuBar from '~/components/dashboard/menuBar.vue'

Vue.component('menu-bar', MenuBar)

@Component<any>({
    middleware: ['authenticate'],
    head() {
        return {
            titleTemplate: '%s | ' + this.$t('dashboard.menu.HOME'),
            title: this.$t('dashboard.menu.CHANGEPASSWORD'),
        }
    },
})
export default class Password extends Vue {
    // Data
    $refs!: { passwordForm: HTMLFormElement }
    ref: any = this.$refs
    pageLoaded: boolean = false
    selectedPage: Number = 6 // password
    showPass: Boolean = false
    showNewPass: Boolean = false
    showConfirmPass: Boolean = false
    formHasErrors: Boolean = false
    isButtonDisabled: Boolean = false
    form: { [key: string]: any } = {
        password: {
            value: '',
            error: null,
            requestKey: 'password',
        },
        newPassword: {
            value: '',
            error: null,
            requestKey: 'newPassword',
        },
        confirmPassword: {
            value: '',
            error: null,
            requestKey: 'confirmPassword',
        },
    }

    // Rules
    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    requiredMin(v: string) {
        if (v) {
            if (v.length >= 8) {
                return true
            }
        }
        return this.$t('form.password.min')
    }

    requiredMatch(v: string) {
        if (v) {
            if (this.form.newPassword.value === v) {
                return true
            }
        }
        return this.$t('form.password.match')
    }

    // Methods
    validateForm() {
        if (typeof this.$refs === 'undefined') {
            return
        }

        setTimeout(() => {
            const valid = this.$refs.passwordForm.validate()

            if (valid) {
                this.submit()
            }
        }, 300)
    }

    submit() {
        this.isButtonDisabled = true

        this.$api.user
            .changePassword(
                this.form.password.value,
                this.form.newPassword.value,
                this.form.confirmPassword.value
            )
            .then(() => {
                // Reset form & error messages
                this.$refs.passwordForm.reset()

                // Display snackbar message
                const val = {
                    text: this.$t('notification.password.success'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)

                this.isButtonDisabled = false
            })
            .catch((error) => {
                if (error.response.status === 401) {
                    return
                }

                if (error.response.status === 422) {
                    // Display snackbar message
                    const val = {
                        text: this.$t('notification.password.failed'),
                        color: 'red',
                        icon: 'mdi-close-circle',
                    }
                    this.$store.dispatch('snackbar/displaySnackBar', val)

                    this.isButtonDisabled = false
                }

                // Get errors object
                const errors = error.response.data.errors

                // Get keys of error
                const errorKeys: string[] = Object.keys(errors)
                const formKeys: string[] = Object.keys(this.form)

                // Set error messages
                for (const errorKey of errorKeys) {
                    for (const formKey of formKeys) {
                        if (this.form[formKey].requestKey === errorKey) {
                            this.form[formKey].error = errors[errorKey].reduce(
                                (message = '', currentMessage: string) => {
                                    return message + ' ' + currentMessage
                                }
                            )
                        }
                    }
                }
            })
    }

    mounted() {
        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }
    }

    created() {
        this.$store.dispatch('menu/selectDashboardMenu', this.selectedPage)
    }
}
</script>
